using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using TIS.Imaging;
using TIS.Imaging.VCDHelpers;

namespace Modifying_Device_Properties
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblBrightnessValue;
		private System.Windows.Forms.CheckBox chkBrightnessAuto;
		private System.Windows.Forms.TrackBar sldBrightness;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			this.label1 = new System.Windows.Forms.Label();
			this.sldBrightness = new System.Windows.Forms.TrackBar();
			this.lblBrightnessValue = new System.Windows.Forms.Label();
			this.chkBrightnessAuto = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sldBrightness)).BeginInit();
			this.SuspendLayout();
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(8, 8);
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.Size = new System.Drawing.Size(368, 256);
			this.icImagingControl1.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 272);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 24);
			this.label1.TabIndex = 1;
			this.label1.Text = "Brightness";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// sldBrightness
			// 
			this.sldBrightness.AutoSize = false;
			this.sldBrightness.Location = new System.Drawing.Point(72, 272);
			this.sldBrightness.Name = "sldBrightness";
			this.sldBrightness.Size = new System.Drawing.Size(176, 24);
			this.sldBrightness.TabIndex = 2;
			this.sldBrightness.Scroll += new System.EventHandler(this.sldBrightness_Scroll);
			// 
			// lblBrightnessValue
			// 
			this.lblBrightnessValue.Location = new System.Drawing.Point(248, 272);
			this.lblBrightnessValue.Name = "lblBrightnessValue";
			this.lblBrightnessValue.Size = new System.Drawing.Size(48, 24);
			this.lblBrightnessValue.TabIndex = 3;
			this.lblBrightnessValue.Text = "0";
			this.lblBrightnessValue.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// chkBrightnessAuto
			// 
			this.chkBrightnessAuto.Location = new System.Drawing.Point(304, 272);
			this.chkBrightnessAuto.Name = "chkBrightnessAuto";
			this.chkBrightnessAuto.Size = new System.Drawing.Size(72, 24);
			this.chkBrightnessAuto.TabIndex = 4;
			this.chkBrightnessAuto.Text = "Auto";
			this.chkBrightnessAuto.CheckedChanged += new System.EventHandler(this.chkBrightnessAuto_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 302);
			this.Controls.Add(this.chkBrightnessAuto);
			this.Controls.Add(this.lblBrightnessValue);
			this.Controls.Add(this.sldBrightness);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.icImagingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sldBrightness)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private VCDSimpleProperty vcdProp = null;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			if( !icImagingControl1.DeviceValid )
			{
				icImagingControl1.ShowDeviceSettingsDialog();
				if( !icImagingControl1.DeviceValid )
				{
					MessageBox.Show( "No device was selected" );
					Close();
					return;
				}
			}
			// Initialize the VCDSimpleProperty class to access the
			// properties of our ICImagingControl object
			vcdProp = new VCDSimpleProperty( icImagingControl1.VCDPropertyItems );

			// Initialize the auto checkbox
			if( !vcdProp.AutoAvailable( VCDIDs.VCDID_Brightness ) )
			{
				chkBrightnessAuto.Enabled = false;
			}
			else
			{
				vcdProp.Automation[VCDIDs.VCDID_Brightness] = false;
			}

			// Initialize the slider
			if( !vcdProp.Available( VCDIDs.VCDID_Brightness ) )
			{
				sldBrightness.Enabled = false;
			}
			else
			{
				sldBrightness.Minimum = vcdProp.RangeMin(VCDIDs.VCDID_Brightness);
				sldBrightness.Maximum = vcdProp.RangeMax(VCDIDs.VCDID_Brightness);
				sldBrightness.Value = vcdProp.RangeValue[VCDIDs.VCDID_Brightness];
				sldBrightness.TickFrequency = (sldBrightness.Maximum - sldBrightness.Minimum) / 10;
				lblBrightnessValue.Text = sldBrightness.Value.ToString();
			}
			// Start live mode
			icImagingControl1.LiveStart();
		}

		private void sldBrightness_Scroll(object sender, System.EventArgs e)
		{
			vcdProp.RangeValue[VCDIDs.VCDID_Brightness] = sldBrightness.Value;
			lblBrightnessValue.Text = sldBrightness.Value.ToString();
		}
		private void chkBrightnessAuto_CheckedChanged(object sender, System.EventArgs e)
		{
			vcdProp.Automation[VCDIDs.VCDID_Brightness] = chkBrightnessAuto.Checked;
			sldBrightness.Enabled = !chkBrightnessAuto.Checked;
		}
	}
}
